%define _requires_exceptions perl(Carp::Heavy)
%define name asterisk

## OPTIONAL DEBUG FLAGS ##
%define debug_threads	0
%{?_without_debug_threads:	%global debug_threads 0}
%{?_with_debug_threads:		%global debug_threads 1}
%define debug_channel_locks 0
%{?_without_debug_channel_locks:	%global debug_channel_locks 0}
%{?_with_debug_channel_locks:		%global debug_channel_locks 1}
# Any debug flag is set?
%define debug_flags %(test %{debug_threads} -eq 1 -o %{debug_channel_locks} -eq 1 && echo 1 || echo 0)
# For use with ? operator, undefine debug_flags if it is false
%if !%{debug_flags}
%undefine debug_flags
%endif

%define	version	1.4.44
# Undefine or comment subver for normal release
%define subver rc6
%undefine subver

# normal release: version-major.minor
# subver release: version-0.subver.major
%define major 6
%define minor 0.moregroups

%define rel		%{?subver:0.%{subver}}%{?!subver:%major}
%define subrel %{?subver:%{major}}%{?!subver:%minor}%{?debug_flags:.debug}
%define release  %mkrel %{rel} %{subrel}

%define realver %{?subver:%{version}-%{subver}}%{?!subver:%{version}}

# %define soundversion 1.4.7

%define dahdiver 2.2.1
%define zaptelver 1.4.12

%define libpriver 1.4.12
%define libopenr2ver 1.3.1
%define openh323ver 1.18.0
%define pwlibver 1.10.0
%define misdnver 1.1.8

%define _varlibdir %{_var}/lib
%define astvarlibdir %{_var}/lib/%{name}
%define astspooldir %{_var}/spool/%{name}
%define astmoddir %{_libdir}/%{name}/modules
%define astrundir %{_var}/run/%{name}
%define astlogdir %{_logdir}/%{name}
%define astsounddir %{astvarlibdir}/sounds
%define astmohdir %{astvarlibdir}/moh

## Build against DAHDI (default) or zaptel ##
%define against_dahdi	1
%{?_without_dahdi:	%global against_dahdi 1}
%{?_with_dadhi:		%global against_dahdi 0}
%{?_without_zaptel:	%global against_dahdi 1}
%{?_with_zaptel:		%global against_dahdi 0}

# OpenR2 support
%define openr2_support 1
%{?_without_openr2:	%global openr2_support 0}
%{?_with_openr2:		%global openr2_support 1}

%define build_h323	1
%{?_without_h323:	%global build_h323 0}
%{?_with_h323:		%global build_h323 1}

%define build_misdn	0
%{?_without_misdn:	%global build_misdn 0}
%{?_with_misdn:		%global build_misdn 1}

%define build_odbc	1
%{?_without_odbc:	%global build_odbc 0}
%{?_with_odbc:		%global build_odbc 1}

%define build_jabber	1
%{?_without_jabber:	%global build_jabber 0}
%{?_with_jabber:	%global build_jabber 1}

%define build_radius	1
%{?_without_radius:	%global build_radius 0}
%{?_with_radius:	%global build_radius 1}

%define build_snmp	1
%{?_without_snmp:	%global build_snmp 0}
%{?_with_snmp: %global build_snmp 1}

# build postgresql support
%define build_pgsql 	1
%{?_without_pgsql: %global build_pgsql 0}
%{?_with_pgsql: %global build_pgsql 1}

%define build_sqlite 	1
%{?_without_sqlite: %global build_sqlite 0}
%{?_with_sqlite: %global build_sqlite 1}

%define build_tds 1
%{?_without_tds: %global build_tds 0}
%{?_with_tds: %global build_tds 1}

%define build_osp 0
%{?_without_osp: %global build_osp 0}
%{?_with_osp: %global build_osp 1}

# SIP over TCP / TLS support: http://bugs.digium.com/view.php?id=4903
%define build_tcp 0
%{?_without_tcp: %global build_tcp 0}
%{?_with_tcp: %global build_tcp 1}

# this takes quite some time...
%define build_docs 1
%{?_without_docs: %global build_docs 0}
%{?_with_docs: %global build_docs 1}

%define is_mdv %(test -f /etc/redhat-release && egrep -q 'Mandriva' /etc/redhat-release && echo 1 || echo 0)
# Definir como global para poder testear contra el valor verdadero 1/0
%global is_centos6 %( test "%{centos_ver}" = "6" && echo 1 || echo 0)

Summary: Asterisk PBX
Name: %{name}
Version: %{version}
Release: %{release}
License: GPL
Group: System/Servers
URL: http://www.asterisk.org/
Source0: http://www.asterisk.org/html/downloads/%{name}-%{realver}.tar.bz2
Source1: asterisk-1.4.initscripts.tar.gz
#Source2: asterisk-1.4-codec_g722-20071005.tar.bz2
Source3: asterisk_logrotate-1.4.txt
#Source10: asterisk-moh-opsound-gsm.tar.gz
#Source11: asterisk-moh-opsound-ulaw.tar.gz
#Source12: asterisk-moh-opsound-g729.tar.gz
Source10: rfc3951.txt
Source11: extract-cfile.awk
Source100: asterisk-1.4.aal.tar.bz2
# AGX Digium chan_sip and chan_misdn patches
Source101: agx-patches-1.4.29.tar.bz2
# Applist file (AEL)
Patch0: asterisk-1.4.42-rpmbuild.patch
##Patch1: asterisk-1.4.24.1-chan_h323.patch
Patch1: asterisk-1.4.42-chan_h323.patch
#Patch1: asterisk-h323-use-pboolean-only.patch
# Add g722 codec support (http://users.netplex.net/~andrew/asterisk/#g722) 
Patch2: g722-20090218.patch.gz
# Select voicemail storage system in modules.conf
Patch3: asterisk-1.4.13-vm_module_load.patch
# Add jitterbuffer to mISDN channel
Patch4: asterisk-1.4.23.1-misdn-jitterbuffer.patch
# Attended Transfer over Manager Interface
Patch5: asterisk-1.4.24.1-att_trans_ami.patch
# Use system libilbc
Patch6: asterisk-1.4.29.1-external_libilbc.patch
# Fix astNumChannel in asterisk MIB file
Patch7: asterisk-1.4.24.1-fix_numchannel_mib.patch
# OpenR2 support
#Patch8: openr2-1.4.26.2-p2.patch 
#Patch8: asterisk-1.4.27-openr2.patch
Patch8: openr2-asterisk-1.4.42-p1.patch
# dtmfenergy callerid support
Patch9: asterisk-1.4.42-9096_dtmfenergy_cid.diff
Patch10: asterisk-1.4.0-freetds_mssql.diff
Patch18: asterisk-1.4.19-imap.patch
Patch20: asterisk-chan_sip-content-length.diff
Patch100: asterisk-1.4.23.1-sip_20070808_tcp.patch
Patch101: asterisk-1.4.13-sip_limit_outgoing.diff
Patch102: asterisk-1.4.42-sysinfo.patch
Patch103: asterisk-1.4.42-safe_asterisk.patch
Patch104: asterisk-1.4.13-frame.patch
Patch105: asterisk-1.4.26-rc2-manager_showtout.patch
Patch106: asterisk-1.4.13-ast_variable_next.patch 
Patch107: asterisk-1.4.13-hangupcause.patch
Patch108: asterisk-1.4.28-busydetect.patch
Patch109: asterisk-1.4.13-monitor_delay.patch
Patch110: asterisk-SVN_branch_1.4-sip_maxretries.patch
Patch111: asterisk-1.4.27-ael_aal.patch
Patch112: asterisk-1.4.13-ael_xapps.patch
Patch113: asterisk-1.4.28-say_lang.patch
patch114: asterisk-1.4.19-sip_name.patch
Patch115: asterisk-1.4.42-qaddons.patch
Patch116: asterisk-1.4.19-qdebug.patch
Patch117: asterisk-1.4.19-sip_info_huawei.patch
Patch118: asterisk-1.4.29.1-rc-kill-safe_asterisk-first.patch 
Patch119: asterisk-1.4.44-init_lsb.patch
# CDRfix4 patch
#Patch120: asterisk-1.4.21.1-cdrpatch4.patch
Patch121: asterisk-SVN_branch_1.4_iax_read.patch
Patch122: asterisk-1.4.22-queue_noanswer.patch
Patch123: asterisk-1.4.23.1-fd.patch
Patch124: asterisk-1.4.24.1-page.patch
Patch125: asterisk-1.4.42-h323-no-deps-on-asterisk.patch
Patch126: asterisk-1.4.24.1-h323-workaround-openh323-segfault.patch
#Patch127: reviewboard_1117.patch
Patch127: asterisk-1.4.42-h323plus_1_22.patch
Patch128: asterisk-1.4.24.1-masquerade_uniqueid.patch
Patch129: asterisk-1.4.27-masquerade_whentohangup.patch
Patch130: asterisk-1.4.29-atxfer_r244151.patch
Patch131: asterisk-1.4.29-16525_r244070.patch
Patch132: asterisk-1.4.29.1-qoptR_r236304.patch
Patch133: asterisk-1.4.42-module_load.patch
# IPContact added features
Patch200: asterisk-1.4.26-rc2-sipiax_show_channels.patch
Patch201: asterisk-1.4.26-rc2-snmp16_backport.patch
Patch202: asterisk-1.4.28-qmc.patch
Patch203: asterisk-1.4.26.2-app_read_timeout.patch
Patch204: asterisk-1.4.42-parking_return.patch
Patch205: asterisk-1.4.43-queue_ring_when_onhold_ringing.patch
Patch206: asterisk-1.4.44-preprocess_vm.patch
Patch207: asterisk-1.4.29.1-automonitor_event.patch
Patch208: asterisk-1.4.29.1-dcxorcomcid.patch
Patch209: asterisk-1.4.44-pri_find_empty.patch
Patch210: asterisk-1.4.44-pickupmark_queue.patch
Patch211: asterisk-1.4.44-qms_qmp.diff
Patch212: asterisk-1.4.44-queue_exists.patch
Patch213: asterisk-1.4.44-queue_cdr.patch
Patch214: asterisk-1.4.44-sharedlastcall_r86985.patch
Patch215: asterisk-1.4.44-audiohookdbg.patch
Patch216: asterisk-1.4.44-moregroups_16640.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-root
Requires(pre): rpm-helper
Requires(postun): rpm-helper
Requires(post): rpm-helper
Requires(preun): rpm-helper
Requires: mpg123
Requires: asterisk-core-sounds
Requires: asterisk-moh
%if %{against_dahdi}
Requires: dahdi-linux >= %{dahdiver}
Requires: dahdi-linux-driver >= %{dahdiver}
BuildRequires: dahdi-linux-devel >= %{dahdiver}
%else
Requires: zaptel >= %{zaptelver}
BuildRequires: zaptel-devel >= %{zaptelver}
%endif
Requires: libpri >= %{libpriver}
%if %{openr2_support}
Requires: libopenr2 >= %{libopenr2ver}
BuildRequires: libopenr2-devel >= %{libopenr2ver}
%endif
BuildRequires: libtool
BuildRequires: autoconf >= 2.60
BuildRequires: automake >= 1.9.6
BuildRequires:	alsa-lib-devel
BuildRequires: curl-devel
BuildRequires: isdn4k-utils-devel
BuildRequires: gsm-devel
#BuildRequires: libilbc-devel
BuildRequires: ncurses-devel
BuildRequires: libpri-devel >= %libpriver
BuildRequires: speex-devel
BuildRequires: libtermcap-devel
BuildRequires: libtiff-devel
BuildRequires: libidn-devel
BuildRequires: libogg-devel
BuildRequires: libvorbis-devel
BuildRequires: openssl-devel
BuildRequires: libcap-devel
BuildRequires: zlib-devel
BuildRequires: newt-devel
BuildRequires: popt
BuildRequires: wget
BuildRequires: perl
BuildRequires: bison
BuildRequires: flex
BuildRequires: imap-devel
BuildRequires: krb5-devel
BuildRequires: pam-devel
%if %{build_docs}
BuildRequires: doxygen
%endif
%if %{build_h323}
BuildRequires: pwlib-devel >= %{pwlibver}
BuildRequires: openh323-devel >= %{openh323ver}
BuildRequires: openldap-devel
BuildRequires: SDL-devel
BuildRequires: expat-devel
%endif
%if %{build_jabber}
BuildRequires: libgcrypt-devel
BuildRequires: gnutls-devel
BuildRequires: libgpg-error-devel
%if %{is_mdv}
BuildRequires: libiksemel-devel >= 1.2
%else
BuildRequires: iksemel-devel >= 1.2
%endif
%endif
%if %build_pgsql
BuildRequires: postgresql-devel
%endif
%if %build_sqlite
%if %{is_mdv}
BuildRequires: sqlite-devel >= 2.0
%else
BuildRequires: sqlite2-devel >= 2.0
%endif
%endif
%if %{build_misdn}
%if %{is_mdv}
BuildRequires: libmisdn-devel >=  %{misdnver}
%else
BuildRequires: mISDNuser-devel >= %{misdnver}
BuildRequires: mISDN-devel >= %{misdnver}
%endif
%endif
%if %{build_odbc}
BuildRequires: unixODBC-devel
%if %{is_mdv}
BuildRequires: libltdl-devel
%else
BuildRequires: libtool-ltdl-devel
%endif
%endif
%if %{build_radius}
BuildRequires: radiusclient-ng-devel
%endif
%if %{build_snmp}
BuildRequires: net-snmp-devel
%if %{is_mdv}
BuildRequires: tcp_wrappers-devel
%else
BuildRequires: tcp_wrappers
BuildRequires: lm_sensors-devel
%endif
%endif
%if %build_tds
BuildRequires: freetds-devel
%endif
%if %build_osp
BuildRequires: libosp-devel
%endif

%description
Asterisk is an Open Source PBX and telephony development platform that
can both replace a conventional PBX and act as a platform for developing
custom telephony applications for delivering dynamic content over a
telephone similarly to how one can deliver dynamic content through a
web browser using CGI and a web server.

Asterisk talks to a variety of telephony hardware including BRI, PRI, 
POTS, and IP telephony clients using the Inter-Asterisk eXchange
protocol (e.g. gnophone or miniphone). For more information and a
current list of supported hardware, see www.asterisk.org.

%if %{build_h323}
%package chan_h323
Summary: This module adds H323 support to the Asterisk PBX
Group: System/Servers
Requires(post): %{name} = %{version}
Requires(preun): %{name} = %{version}

%description chan_h323
This module provides chan_h323 in a separate package with its
dependencies. In this way main asterisk package doesn't depend
on h323 dependencies.
%endif

%if %{build_misdn}
%package chan_misdn
Summary: This module adds mISDN support to the Asterisk PBX
Group: System/Servers
Requires(post): %{name} = %{version}
Requires(preun): %{name} = %{version}

%description chan_misdn
This module adds mISDN support to the Asterisk PBX. mISDN is the
(experimental) new ISDN4Linux stack, which adds support for
driving cards in NT mode and thus connecting an ISDN phone to your
computer.
%endif

%package devel
Summary: Header files for building Asterisk modules
Group: Development/C

%description devel
This package contains the development header files that are needed
to compile 3rd party modules.

%package docs
Summary: The Hitchhiker's Guide to Asterisk
Group: Books/Howtos

%description docs
The Hitchhiker's Guide to Asterisk

%if %{build_odbc}
%package plugins-odbc
Summary: ODBC plugins for Asterisk
Group: System/Servers
Requires(post): %{name} = %{version}
Requires(preun): %{name} = %{version}

%description plugins-odbc
This package contains ODBC plugins for Asterisk:

* ODBC Configuration
* Call Detail Recording for ODBC
* ODBC resource manager
%endif

%if %build_pgsql
%package plugins-pgsql
Summary: PostgreSQL plugins for Asterisk
Group: System/Servers
Requires(post): %{name} = %{version}
Requires(preun): %{name} = %{version}

%description plugins-pgsql
This package contains PostgreSQL plugins for Asterisk:

* Simple PostgreSQL Interface
* Call Detail Recording for PostgreSQL
%endif

%if %{build_radius}
%package plugins-radius
Summary: Radiusclient plugins for Asterisk
Group: System/Servers
Requires(post): %{name} = %{version}
Requires(preun): %{name} = %{version}

%description plugins-radius
This package contains Radiusclient plugins for Asterisk:

* Call Detail Recording for Radius
%endif

%if %build_sqlite
%package plugins-sqlite
Summary: SQLite plugins for Asterisk
Group: System/Servers
Requires(post): %{name} = %{version}
Requires(preun): %{name} = %{version}

%description plugins-sqlite
This package contains SQLite plugins for Asterisk:

* Call Detail Recording for SQLite
%endif

%if %build_tds
%package plugins-tds
Summary: FreeTDS plugins for Asterisk
Group: System/Servers
Requires(post): %{name} = %{version}
Requires(preun): %{name} = %{version}
Requires: freetds

%description plugins-tds
This package contains FreeTDS plugins for Asterisk:

* Call Detail Recording for FreeTDS
%endif

%if %{build_osp}
%package plugins-osp
Summary: Open Settlement Protocol for Asterisk
Group: System/Servers
Requires(post): %{name} = %{version}
Requires(preun): %{name} = %{version}

%description plugins-osp
This package contains OSP (Open Settlement Protocol) support for Asterisk
%endif

%if %{build_snmp}
%package plugins-snmp
Summary: SNMP Agent / SubAgent support for Asterisk
Group: System/Servers
Requires: net-snmp
Requires(post): %{name} = %{version}
Requires(preun): %{name} = %{version}
Requires: %{name}-snmp-mibs


%description plugins-snmp
This package contains brief SNMP Agent / SubAgent support for Asterisk.

%package snmp-mibs
Summary: Asterisk MIB files for SNMP management
Group: System/Servers
Requires: net-snmp
BuildArch: noarch

%description snmp-mibs
This package contains de MIBS data files to support
Asterisk  SNMP agent management.
%endif

%if %{build_jabber}
%package plugins-jabber
Summary: Jabber support for Asterisk
Group: System/Servers
Requires(post): %{name} = %{version}
Requires(preun): %{name} = %{version}

%description plugins-jabber
This package contains Jabber support for Asterisk.

* res_jabber - A resource for interfacing asterisk directly as a client or a
              component to a jabber compliant server.

* chan_gtalk - brief Gtalk Channel Driver, until google/libjingle works with
              jingle spec.
%endif


%package webvmail
Summary: Web frontend to voicemail
Group: System/Servers
Requires: %{name} = %{version}-%{release}
Requires: webserver

%description webvmail
This package contains the web frontend to voicemail.

WARNING:
IT USES A SETUID ROOT PERL SCRIPT, SO IF YOU DON'T LIKE THAT,
DO NOT INSTALL THIS PACKAGE!

%prep
%setup -n %{name}-%{realver} -q -a1 -a100 -a101

%{__cp}  -v %{SOURCE10} codecs/ilbc
%{__cp}  -v %{SOURCE11} codecs/ilbc

# Apply AGX patches submitted to Digium
pushd channels
patch -p0 < ../agx-patches/chan_sip.1.patch
patch -p0 < ../agx-patches/chan_misdn.1.patch
popd

%patch0 -p1 -b .rpm
%if %{build_h323}
%patch1 -p1 -b .h323
%endif
%patch2 -p0 -b .g722
%patch3 -p1 -b .vmload
%patch4 -p1 -b .misdnj
##%patch5 -p1 -b .attami
##patch6 -p1 -b .libilbc
%patch7 -p1 -b .astmib
%patch9 -p1 -b .dtmfcid
%if %{openr2_support}
%patch8 -p0 -b .openr2
%endif
# Fix LIBILBC path (avoid conflict with g722 patch)
#perl -pi -e "s/LIBILBC:=.*/LIBILBC:=-lilbc/" codecs/Makefile

%if %{build_tds}
#%patch10 -p1 -b .freetds_mssql
%endif
%patch18 -p0 -b .imap
%patch20 -p0 -b .content_length
%if %{build_tcp}
# SIP over TCP
%patch100 -p1 -b .tcp.patch
%endif
%patch101 -p1 -b .siplimit
%patch102 -p1 -b .sysinfo
%patch103 -p1 -b .safeast
%patch118 -p1 -b .rc
%patch119 -p1 -b .lsb
%patch104 -p1 -b .frame
%patch105 -p1 -b .showtout
%patch106 -p1 -b .varnext
%patch107 -p1 -b .hupcause
%patch108 -p1 -b .busy
%patch109 -p0 -b .mondelay
%patch110 -p0 -b .sipmaxret
%patch111 -p1 -b .aelaal
%patch112 -p0 -b .aelxapp
%patch113 -p1 -b .saylang
%patch114 -p0 -b .sipname
%patch115 -p1 -b .qadds
%patch116 -p1 -b .qdebug
%patch117 -p1 -b .huawei
#%patch118 -p1 -b .lastapp
#%patch120 -p1 -b .cdrpatch4
%patch121 -p1 -b .iaxread
%patch122 -p1 -b .qnoanswer
%patch123 -p1 -b .fd
%patch124 -p1 -b .page
%if %{build_h323}
%patch125 -p1 -b .h323nodep
%if !%{is_centos6}
%patch126 -p1 -b .h323workaround
%endif
##%patch127 -p1 -b .h323plus_1_22
%endif
%patch128 -p1 -b .masquerade
%patch129 -p1 -b .whentohangup
##%patch130 -p2 -b .atxfer
##%patch131 -p0 -b .atxfer2
%patch132 -p1 -b .qoptR
%patch133 -p1 -b .moduleload

%patch200 -p1 -b .sipiaxdialogs
%patch201 -p1 -b .snmp16
%patch202 -p1 -b .qmc
%patch203 -p1 -b .readtout
%patch204 -p1 -b .parkret
%patch205 -p1 -b .ringinuse
%patch206 -p1 -b .preprocvm
%patch207 -p1 -b .automon
%patch208 -p1 -b .dcxorcom
%patch209 -p1 -b .prifindempty
%patch210 -p1 -b .pickupqueue
%patch211 -p1 -b .qmsqmp
%patch212 -p1 -b .queueexists
%patch213 -p1 -b .queuecdr
%patch214 -p1 -b .sharedlastcall
%patch215 -p1 -b .audiohookdbg
%patch216 -p1 -b .moregroups

# copy the sound files to the proper directory
#%{__cp}  -v %{SOURCE10} sounds/
#%{__cp}  -v %{SOURCE11} sounds/
#%{__cp}  -v %{SOURCE12} sounds/

find . -type d -perm 0700 -exec chmod 755 {} \;
find . -type d -perm 0555 -exec chmod 755 {} \;
find . -type f -perm 0555 -exec chmod 755 {} \;
find . -type f -perm 0444 -exec chmod 644 {} \;

for i in `find . -type d -name CVS` `find . -type f -name .cvs\*` `find . -type f -name .#\*`; do
  if [ -e "$i" ]; then rm -rf $i; fi >&/dev/null
done

# lib64 fix
find -name "Makefile" | xargs perl -pi -e "s|/usr/lib|%{_libdir}|g"
perl -pi -e "s|/lib\b|/%{_lib}|g" configure*
perl -pi -e "s|/lib/|/%{_lib}/|g" configure*

# Fix included plc.h to not conflict with same file from spandsp
perl -pi -e "s|_PLC_H_|_SPANDSP_PLC_H_|g" include/asterisk/plc.h
# temporary hack
#cp %{_includedir}/spandsp/plc.h include/asterisk/

## DEBUG FLAGS ##
# Generate a build report with compiler flags options
touch BUILD_REPORT
cat >> BUILD_REPORT << "EOF"
Asterisk Build Report
*********************

EOF
echo "Version:       %{version}-%{release}" >> BUILD_REPORT
echo "Build date:    `date +"%a %b %d %Y at %r"`" >> BUILD_REPORT
echo -e "\nCompiler FLAGS:\n" >> BUILD_REPORT
echo -e "LOADABLE_MODULES\nDONT_OPTIMIZE" >> BUILD_REPORT
# Always use DONT_OPTIMIZE
perl -pi -e's,(.+DONT_OPTIMIZE.*),$1\n\t\t\t<defaultenabled>yes</defaultenabled>,' build_tools/cflags.xml
# Optional debug flags
%if %{debug_threads}
perl -pi -e's,(.+DEBUG_THREADS.*),$1\n\t\t\t<defaultenabled>yes</defaultenabled>,' build_tools/cflags.xml
echo "DEBUG_THREADS" >> BUILD_REPORT
%endif
%if %{debug_channel_locks}
perl -pi -e's,(.+DEBUG_CHANNEL_LOCKS.*),$1\n\t\t\t<defaultenabled>yes</defaultenabled>,' build_tools/cflags.xml
echo "DEBUG_CHANNEL_LOCKS" >> BUILD_REPORT
%endif

# Get ILBC source
# Patch source to not wait for a key press and to don't download anything
perl -pi -e 's,read tmp,,' contrib/scripts/get_ilbc_source.sh
perl -pi -e 's,^wget .+,,g' contrib/scripts/get_ilbc_source.sh
contrib/scripts/get_ilbc_source.sh

# # introduce some sanity before bootstrapping on RHEL5/CentOS5
# %if 0%{?is_rhel:1}
# # fix hardcoded requirement for autoconf 2.60 (RHEL5/CentOS5 has 2.59)
# ##%{__perl} -pi -e's,2.60,2.59,' configure.ac
# # remove sed check
# ##%{__perl} -pi -e's,^AC\_REQUIRE\(\[AST\_PROG\_SED\]\)dnl,#AC\_REQUIRE\(\[AST\_PROG\_SED\]\)dnl,' acinclude.m4
# # disable AC_USE_SYSTEM_EXTENSIONS
### Esto genera problemas para autoconf > 2.60!! eliminar, hace que no se defina _GNU_SOURCE en include/asterisk/autoconfig.h ###
# %{__perl} -pi -e's,^AC\_USE\_SYSTEM\_EXTENSIONS,#AC\_USE\_SYSTEM\_EXTENSIONS,' configure.ac
# %endif

%build
# Fix localstatedir caused by Mandriva's rpm-manbo-setup package
%if %{is_mdv}
%define _localstatedir /var
%endif
%serverbuild
sh ./bootstrap.sh
#echo "%{version}-%{release} by ipcontact@ipcontact.com.uy" > .version
echo "%{version}-%{release}" > .version

pushd menuselect/mxml
%configure
popd
pushd menuselect
%configure
popd 
pushd main/editline
%configure
popd

# ASTCFLAGS with -fPIC needed for compiling pbx/aal pbx/ael for x86_64
export ASTCFLAGS="%{optflags} -fPIC"
%configure --without-kde --without-tinfo --without-vpb \
%if !%{build_h323}
  --without-pwlib \
  --without-h323 \
%endif
  --with-imap=%{_prefix} \
  --with-asound=%{_prefix} \
  --with-curses=%{_prefix} \
  --with-gnutls=%{_prefix} \
  --with-gsm=%{_prefix} \
  --with-iksemel=%{_prefix} \
  --with-isdnnet=%{_prefix} \
%if %{build_misdn}
  --with-misdn=%{_prefix} \
%else
 --without-misdn \
%endif
%if %{build_odbc}
  --with-odbc=%{_prefix} \
%else
 --without-odbc \
%endif
%if %{build_pgsql}
 --with-postgres=%{_prefix} \
%else
 --without-postgres \
%endif
%if %{build_radius}
  --with-radius=%{_prefix} \
%else
 --without-radius \
%endif
%if %{build_tds}
  --with-tds=%{_prefix} \
%else
 --without-tds \
%endif
  --with-ncurses=%{_prefix} \
%if %{build_snmp}
  --with-netsnmp=%{_prefix} \
%else
  --without-netsnmp \
%endif
  --with-newt=%{_prefix} \
  --with-ogg=%{_prefix} \
%if %{build_osp}
  --with-osptk=%{_prefix} \
%else
  --without-osptk \
%endif
  --with-oss=%{_prefix} \
  --with-popt=%{_prefix} \
  --with-pri=%{_prefix} \
  --with-speex=%{_prefix} \
%if %build_sqlite
  --with-sqlite=%{_prefix} \
%else
 --without-sqlite \
%endif
  --with-suppserv=%{_prefix} \
  --with-ssl=%{_prefix} \
  --with-termcap=%{_prefix} \
  --with-tonezone=%{_prefix} \
  --with-vorbis=%{_prefix} \
  --with-z=%{_prefix} \
%if %{against_dahdi}
  --with-dahdi=%{_prefix} \
%else
  -with-zaptel=%{_prefix} \
%endif
%if %{_lib} == lib64
  LIB64=1 \
%endif
  HTTPDIR="/var/www"
%{__make} include/asterisk/buildopts.h

# Enable ILBC codec
perl -pi -e 'undef $/; s,(<member name="codec_ilbc.*>)\n.*<defaultenabled>no</defaultenabled>,$1\n\t<defaultenabled>yes</defaultenabled>,' menuselect-tree #"
rm -f menuselect.makeopts
menuselect/menuselect --check-deps menuselect.makeopts

# Prepare chan_h323 support library 
%if %{build_h323}
#pushd channels
%{__make} -C channels/h323
#popd
%endif

%{__make} NOISY_BUILD=yes BUSYDETECT="-DBUSYDETECT_MARTIN -DBUSYDETECT_TONEONLY"

%if %{build_docs}
# generate the API documents - warning: very slow and tedious
ASTCFLAGS="%{optflags}" %make progdocs
%endif



%install
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}

%{__install} -d %{buildroot}%{_var}/www/{html,cgi-bin}

%makeinstall_std ASTSBINDIR="%{_sbindir}" ASTVARRUNDIR="%{astrundir}" HTTPDIR="%{_var}/www"
%{__make} DESTDIR=%{buildroot} ASTVARRUNDIR="%{astrundir}" samples
%{__make} DESTDIR=%{buildroot} webvmail

# Use asterisk-moh-opsound package
# Install MOH sound files
#%{__install} -d -m 0755 %{buildroot}%{astmohdir}
# Opsound
#%{__make} -C sounds DESTDIR=%{buildroot} ASTDATADIR=%{astvarlibdir} %{buildroot}%{astmohdir}/.asterisk-moh-opsound-wav
#%{__make} -C sounds DESTDIR=%{buildroot} ASTDATADIR=%{astvarlibdir} %{buildroot}%{astmohdir}/.asterisk-moh-opsound-ulaw
#%{__make} -C sounds DESTDIR=%{buildroot} ASTDATADIR=%{astvarlibdir} %{buildroot}%{astmohdir}/.asterisk-moh-opsound-gsm
#%{__make} -C sounds DESTDIR=%{buildroot} ASTDATADIR=%{astvarlibdir} %{buildroot}%{astmohdir}/.asterisk-moh-opsound-g729
#for i in sounds/asterisk-moh-freeplay-*.tar.gz; do
#  cat $i | (cd %{buildroot}%{astmohdir} && tar xfz -)
#done

# Don't fiddle with the initscript!
export DONT_GPRINTIFY=1

# Manually create a few needed directories
%{__install} -d -m 0755 %{buildroot}%{_sysconfdir}/sysconfig
%{__install} -d -m 0755 %{buildroot}%{_sysconfdir}/logrotate.d
%{__install} -d -m 0755 %{buildroot}%{_initrddir}
%{__install} -d -m 0755 %{buildroot}%{_datadir}/snmp/mibs
%{__install} -d -m 0755 %{buildroot}%{astrundir}
# create the spool directories
%{__install} -d -m 0755 %{buildroot}%{astspooldir}
%{__install} -d -m 0755 %{buildroot}%{astspooldir}/fax
%{__install} -d -m 0755 %{buildroot}%{astspooldir}/outgoing
%{__install} -d -m 0755 %{buildroot}%{astspooldir}/monitor

# Install startup scrips
%{__install} -m 0755 initscripts/asterisk.init %{buildroot}%{_initrddir}/asterisk
%{__install} -m 0644 initscripts/asterisk.sysconfig %{buildroot}%{_sysconfdir}/sysconfig/asterisk
%{__install} -m 0644 initscripts/safe_asterisk.sysconfig %{buildroot}%{_sysconfdir}/sysconfig/safe_asterisk
# Manually install the logrotate file
%{__install} -m 0644 %{SOURCE3} %{buildroot}%{_sysconfdir}/logrotate.d/asterisk
# manually install the uppercase version of the MIB files for SNMP management
%{__install} -m 0644 doc/asterisk-mib.txt %{buildroot}%{_datadir}/snmp/mibs/ASTERISK-MIB.txt
%{__install} -m 0644 doc/digium-mib.txt %{buildroot}%{_datadir}/snmp/mibs/DIGIUM-MIB.txt

# Initialize ghost files to make install happy
touch %{buildroot}%{_varlibdir}/%{name}/astdb
touch %{buildroot}%{_logdir}/asterisk/console
touch %{buildroot}%{_logdir}/asterisk/debug
touch %{buildroot}%{_logdir}/asterisk/messages
touch %{buildroot}%{_logdir}/asterisk/queue_log
touch %{buildroot}%{_logdir}/asterisk/event_log
touch %{buildroot}%{_logdir}/asterisk/cdr-csv/Master.csv
%if %{build_h323}
touch %{buildroot}%{_logdir}/asterisk/h323_log
%endif
touch %{name}-devel.filelist

# Fix incorrect path in /etc/asterisk/asterisk.conf
perl -pi -e "s|astrundir => %{_var}/run|astrundir => %{astrundir}|g" %{buildroot}/%{_sysconfdir}/%{name}/asterisk.conf
perl -pi -e "s|^libdir=.*|libdir=%{_libdir}|g" %{buildroot}%{_libdir}/pkgconfig/asterisk.pc
perl -pi -e "s|^varrundir=.*|varrundir=%{astrundir}|g" %{buildroot}%{_libdir}/pkgconfig/asterisk.pc

perl -pi -e "s|;\[options\]|[options]|" %{buildroot}/%{_sysconfdir}/%{name}/asterisk.conf
# Use new sound language prefix path syntax
perl -pi -e "s|;\s*languageprefix\s*=.*|languageprefix = yes|" %{buildroot}/%{_sysconfdir}/%{name}/asterisk.conf
# Enable realtime priority 
perl -pi -e "s|;\s*highpriority\s*=.*|highpriority = yes|" %{buildroot}/%{_sysconfdir}/%{name}/asterisk.conf
# move the asterisk sample files to /etc/asterisk-{version}_samples
%{__mv} -v %{buildroot}/%{_sysconfdir}/%{name} %{buildroot}/%{_sysconfdir}/%{name}-%{version}_samples
# and create the Asterisk configuration directory where the real stuff will live
%{__install} -d -m 0755 %{buildroot}/%{_sysconfdir}/%{name}


# Install directory to add extra apps definitions lists for ael2
%{__install} -d %{buildroot}%{astvarlibdir}/applist.d
%{__install} -m 0644 pbx/aal/applist %{buildroot}%{astvarlibdir}/applist

# TODO
# Add directory for ssl certs
#mkdir -p %{buildroot}%{_sysconfdir}/ssl/%{name}

# Remove moh leftover files
#%{__rm} -f %{buildroot}%{astmohdir}/.asterisk-moh*
#%{__mv} -f %{buildroot}%{astmohdir}/*asterisk-moh* sounds/
# use the stand alone asterisk-core-sounds package instead
#%{__rm} -rf %{buildroot}%{astsounddir}


%pre
%_pre_useradd asterisk %{astvarlibdir} /bin/sh

%post
%create_ghostfile %{astvarlibdir}/astdb asterisk asterisk 644
%create_ghostfile %{astlogdir}/console asterisk asterisk 644
%create_ghostfile %{astlogdir}/debug asterisk asterisk 644
%create_ghostfile %{astlogdir}/messages asterisk asterisk 644
%create_ghostfile %{astlogdir}/queue_log asterisk asterisk 644
%create_ghostfile %{astlogdir}/event_log asterisk asterisk 644
%create_ghostfile %{astlogdir}/cdr-csv/Master.csv asterisk asterisk 644
%if %{build_h323}
%create_ghostfile %{astlogdir}/h323_log asterisk asterisk 644
%endif

echo "Adding setuid root to /usr/bin/mpg123, needed for MOH"
chmod u+s %{_bindir}/mpg123
%_post_service asterisk

%preun
if [ "$1" = 0 ]; then
  echo "Removing setuid root from /usr/bin/mpg123"
  chmod u-s %{_bindir}/mpg123
fi

# TODO
# generate the ldap.pem cert here instead of the initscript
#"/etc/ssl/asterisk/trustcerts.pem"
#"/etc/ssl/asterisk/trustdir"
#"/etc/ssl/asterisk/servercert.pem"
#"/etc/ssl/asterisk/serverkey.pem"
#"/etc/ssl/asterisk/dh512.pem"
#"/etc/ssl/asterisk/dh1024.pem"
#if [ ! -e %{_sysconfdir}/ssl/%{name}/ldap.pem ] ; then
# if [ -x %{_datadir}/%{name}/gencert.sh ] ; then
# echo "Generating self-signed certificate..."
# pushd %{_sysconfdir}/ssl/%{name}/ > /dev/null
# yes ""|%{_datadir}/%{name}/gencert.sh >/dev/null 2>&1
# chmod 640 ldap.pem
# chown root:ldap ldap.pem
# popd > /dev/null
# fi
# echo "To generate a self-signed certificate, you can use the utility"
# echo "%{_datadir}/%{name}/gencert.sh..."
#fi

%_preun_service asterisk

%postun
%_postun_userdel asterisk

%clean
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc BUGS ChangeLog CREDITS LICENSE README* BUILD_REPORT
%doc contrib/init.d/rc.mandrake* contrib/asterisk-ices.xml
%doc contrib/scripts contrib/i18n.testsuite.conf contrib/README.festival
%attr(0755,root,root) %{_initrddir}/asterisk
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/logrotate.d/asterisk
%attr(0750,asterisk,asterisk) %dir %{_sysconfdir}/%{name}
%attr(0750,asterisk,asterisk) %dir %{_sysconfdir}/%{name}-%{version}_samples
%attr(0644,asterisk,asterisk) %{_sysconfdir}/%{name}-%{version}_samples/*.adsi
%attr(0644,asterisk,asterisk) %{_sysconfdir}/%{name}-%{version}_samples/*.conf
%attr(0644,asterisk,asterisk) %{_sysconfdir}/%{name}-%{version}_samples/extensions.ael
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/sysconfig/*asterisk
# TODO
#attr(0750,root,asterisk) %dir  %{_sysconfdir}/ssl/asterisk
%attr(0755,root,root) %{_sbindir}/aelparse
%attr(0755,root,root) %{_sbindir}/asterisk
%attr(0755,root,root) %{_sbindir}/astgenkey
%attr(0755,root,root) %{_sbindir}/astman
%attr(0755,root,root) %{_sbindir}/autosupport
%attr(0755,root,root) %{_sbindir}/muted
%attr(0755,root,root) %{_sbindir}/rasterisk
%attr(0755,root,root) %{_sbindir}/safe_asterisk
%attr(0755,root,root) %{_sbindir}/smsq
%attr(0755,root,root) %{_sbindir}/stereorize
%attr(0755,root,root) %{_sbindir}/streamplayer
%attr(0755,root,root) %dir %{_libdir}/%{name}
%attr(0755,root,root) %dir %{astmoddir}
%attr(0755,root,root) %{astmoddir}/app_*.so
%attr(0755,root,root) %{astmoddir}/cdr_*.so
%attr(0755,root,root) %{astmoddir}/chan_*.so
%attr(0755,root,root) %{astmoddir}/codec_*.so
%attr(0755,root,root) %{astmoddir}/format_*.so
%attr(0755,root,root) %{astmoddir}/func_*.so
%attr(0755,root,root) %{astmoddir}/pbx_*.so
%attr(0755,root,root) %{astmoddir}/res_*.so

# These are packaged as sub packages below
# H323
%exclude  %{_sysconfdir}/%{name}-%{version}_samples/h323.conf
%if %{build_h323}
%exclude  %{astmoddir}/chan_h323.so
%endif
# MISDN
%exclude  %{_sysconfdir}/%{name}-%{version}_samples/misdn.conf
%if %{build_misdn}
%exclude  %{astmoddir}/chan_misdn.so
%endif
# ODBC
%exclude  %{_sysconfdir}/%{name}-%{version}_samples/*_odbc.conf
%if %{build_odbc}
%exclude  %{astmoddir}/*_odbc.so
%endif
# TDS
%exclude  %{_sysconfdir}/%{name}-%{version}_samples/*tds*.conf
%if %{build_tds}
%exclude  %{astmoddir}/*tds*.so
%endif
# PGSQL
%exclude  %{_sysconfdir}/%{name}-%{version}_samples/cdr_pgsql.conf
%if %{build_pgsql}
%exclude  %{astmoddir}/cdr_pgsql.so
%exclude  %{astmoddir}/res_config_pgsql.so
%endif
# RADIUS
%if %{build_radius}
%exclude  %{astmoddir}/cdr_radius.so
%endif
# SQLITE
%if %{build_sqlite}
%exclude  %{astmoddir}/cdr_sqlite.so
%endif
# JABBER
%exclude  %{_sysconfdir}/%{name}-%{version}_samples/gtalk.conf
%exclude  %{_sysconfdir}/%{name}-%{version}_samples/jabber.conf
%if %{build_jabber}
%exclude  %{astmoddir}/chan_gtalk.so
%exclude  %{astmoddir}/res_jabber.so
%endif
# OSP
%if %{build_osp}
%exclude  %{_sysconfdir}/%{name}-%{version}_samples/osp.conf
%exclude  %{astmoddir}/app_osplookup.so
%endif
# SNMP
%exclude  %{_sysconfdir}/%{name}-%{version}_samples/res_snmp.conf
%if %{build_snmp}
%exclude  %{astmoddir}/res_snmp.so
%endif

%attr(0755,asterisk,asterisk) %dir  %{astvarlibdir}
%attr(0755,root,root) %dir  %{astvarlibdir}/agi-bin
%attr(0755,root,root) %{astvarlibdir}/agi-bin/*
%attr(644,asterisk,asterisk) %ghost %{astvarlibdir}/astdb
%attr(0755,root,root) %dir  %{astvarlibdir}/images
%attr(0644,root,root) %{astvarlibdir}/images/*.jpg
%attr(0755,root,root) %dir  %{astvarlibdir}/keys
%attr(0644,root,root) %{astvarlibdir}/keys/*.pub
#%attr(0755,root,root) %dir  %{astmohdir}
#%attr(0644,root,root) %{astmohdir}/*.wav
#%attr(0644,root,root) %{astmohdir}/*.gsm
#%attr(0644,root,root) %{astmohdir}/*.ulaw
#%attr(0644,root,root) %{astmohdir}/*.g729
#%attr(0644,root,root) %{astmohdir}/CHANGES*
#%attr(0644,root,root) %{astmohdir}/*.g722
%attr(0755,root,root) %dir  %{astvarlibdir}/static-http
%attr(0644,root,root) %{astvarlibdir}/static-http/*
%attr(644,asterisk,asterisk) %{astvarlibdir}/applist
%attr(644,asterisk,asterisk) %dir %{astvarlibdir}/applist.d
%attr(0750,asterisk,asterisk) %dir  %{astlogdir}
%attr(0750,asterisk,asterisk) %dir  %{astlogdir}/cdr-csv
%attr(644,asterisk,asterisk) %ghost %{astlogdir}/cdr-csv/Master.csv
%attr(0750,asterisk,asterisk) %dir  %{astlogdir}/cdr-custom
%attr(644,asterisk,asterisk) %ghost %{astlogdir}/console
%attr(644,asterisk,asterisk) %ghost %{astlogdir}/debug
%attr(644,asterisk,asterisk) %ghost %{astlogdir}/event_log
%if %{build_h323}
%attr(644,asterisk,asterisk) %ghost %{astlogdir}/h323_log
%endif
%attr(644,asterisk,asterisk) %ghost %{astlogdir}/messages
%attr(644,asterisk,asterisk) %ghost %{astlogdir}/queue_log

%attr(0750,asterisk,asterisk) %dir  %{astrundir}
%attr(0750,asterisk,asterisk) %dir  %{astspooldir}
%attr(0750,asterisk,asterisk) %dir  %{astspooldir}/monitor
%attr(0750,asterisk,asterisk) %dir  %{astspooldir}/outgoing
%attr(0750,asterisk,asterisk) %dir  %{astspooldir}/fax
%attr(0750,asterisk,asterisk) %dir  %{astspooldir}/voicemail
%attr(0750,asterisk,asterisk) %dir  %{astspooldir}/voicemail/default
%{_mandir}/man8/asterisk.8*
%{_mandir}/man8/astgenkey.8*
%{_mandir}/man8/autosupport.8*
%{_mandir}/man8/safe_asterisk.8*

%files devel -f %{name}-devel.filelist
%defattr(-,root,root)
%attr(0644,root,root) %{_includedir}/asterisk/*.h
%attr(0644,root,root) %{_includedir}/asterisk.h
%attr(0644,root,root) %{_libdir}/pkgconfig/asterisk.pc
#exclude  %{_includedir}/asterisk/defaults.h
#multiarch %{multiarch_includedir}/asterisk/defaults.h

%files docs
%defattr(-,root,root)
%doc doc/*README* doc/*.txt 
%if %{build_docs}
%doc doc/api/html
%endif


%if %{build_h323}
%files chan_h323
%defattr(-,root,root)
%attr(0644,asterisk,asterisk) %{_sysconfdir}/%{name}-%{version}_samples/h323.conf
%attr(0755,root,root) %{astmoddir}/chan_h323.so
%endif

%if %{build_misdn}
%files chan_misdn
%defattr(-,root,root)
%attr(0644,asterisk,asterisk) %{_sysconfdir}/%{name}-%{version}_samples/misdn.conf
%attr(0755,root,root) %{astmoddir}/chan_misdn.so
%endif

%if %{build_odbc}
%files plugins-odbc
%defattr(-,root,root)
%attr(0644,asterisk,asterisk) %{_sysconfdir}/%{name}-%{version}_samples/*_odbc.conf
%attr(0755,root,root) %{astmoddir}/*_odbc.so
%endif

%if %build_pgsql
%files plugins-pgsql
%defattr(-,root,root)
%attr(0644,asterisk,asterisk) %{_sysconfdir}/%{name}-%{version}_samples/cdr_pgsql.conf
%attr(0755,root,root) %{astmoddir}/cdr_pgsql.so
%attr(0755,root,root) %{astmoddir}/res_config_pgsql.so
%endif

%if %{build_radius}
%files plugins-radius
%defattr(-,root,root)
%attr(0755,root,root) %{astmoddir}/cdr_radius.so
%endif

%if %{build_sqlite}
%files plugins-sqlite
%defattr(-,root,root)
%attr(0755,root,root) %{astmoddir}/cdr_sqlite.so
%endif

%if %build_tds
%files plugins-tds
%defattr(-,root,root)
%attr(0644,asterisk,asterisk) %{_sysconfdir}/%{name}-%{version}_samples/cdr_tds.conf
%attr(0755,root,root) %{astmoddir}/cdr_tds.so
%endif

%if %{build_osp}
%files plugins-osp
%defattr(-,root,root)
%attr(0644,asterisk,asterisk) %{_sysconfdir}/%{name}-%{version}_samples/osp.conf
%attr(0755,root,root) %{astmoddir}/app_osplookup.so
%endif

%if %{build_snmp}
%files plugins-snmp
%defattr(-,root,root)
%attr(0644,asterisk,asterisk) %{_sysconfdir}/%{name}-%{version}_samples/res_snmp.conf
%attr(0755,root,root) %{astmoddir}/res_snmp.so
%endif

%files snmp-mibs
%doc doc/snmp.txt 
# Asterisk MIB files for SNMP management
%attr(0644,root,root)	%{_datadir}/snmp/mibs/ASTERISK-MIB.txt
%attr(0644,root,root)	%{_datadir}/snmp/mibs/DIGIUM-MIB.txt

%if %{build_jabber}
%files plugins-jabber
%defattr(-,root,root)
%attr(0644,asterisk,asterisk) %{_sysconfdir}/%{name}-%{version}_samples/gtalk.conf
%attr(0644,asterisk,asterisk) %{_sysconfdir}/%{name}-%{version}_samples/jabber.conf
%attr(0755,root,root) %{astmoddir}/chan_gtalk.so
%attr(0755,root,root) %{astmoddir}/res_jabber.so
%endif

%files webvmail
%defattr(-,root,root)
%attr(4755,root,root) %{_var}/www/cgi-bin/vmail.cgi
%attr(-,root,root) %dir %{_var}/www/html/_asterisk
%attr(0644,root,root) %{_var}/www/html/_asterisk/animlogo.gif
%attr(0644,root,root) %{_var}/www/html/_asterisk/play.gif


%changelog
* Fri Jan 31 2014 Daniel Ferrer <daniel@teledata.com.uy> 1.4.44-6.0.moregroups
- Backport moregroups-16640.patch
  https://reviewboard.asterisk.org/r/466/
  Extend callgroups/pickupgroups from 64 to 1024 (compile-time parameter)
  Add parameters callgroup/pickupgroup to ${SIPPEER()} function
- Fix code patch #206 preprocess_vm.patch, no default format available
  if preprecessfmt is empty

* Mon Jan 20 2014 Daniel Ferrer <daniel@teledata.com.uy> 1.4.44-5.1
- Audiohook debug patch (show dbg info with debug >=3)

* Mon Oct 28 2013 Daniel Ferrer <daniel@teledata.com.uy> 1.4.44-5.0
- Patch213: CDR patch, https://reviewboard.asterisk.org/r/2064
  Don't mark rejected agent calls as BUSY, mark as NOANSWER.
  Lost calls cdr sometimes is not written
- Patch214: Add app_queue option 'shared_lastcall', queue now
  respects wrapuptime from another queue for shared members.
  Backported from trunk/1.8:
  http://svnview.digium.com/svn/asterisk?view=revision&revision=86985

* Tue Dec 11 2012 Daniel Ferrer <daniel@teledata.com.uy> 1.4.44-4.1
- Fix asterisk init script, make it LSB compliant:
  http://refspecs.linux-foundation.org/LSB_3.2.0/LSB-Core-generic/LSB-Core-generic/iniscrptact.html

* Mon Sep 17 2012 Daniel Ferrer <daniel@teledata.com.uy> 1.4.44-4.0
- Add QUEUE_MEMBER_PAUSED, QUEUE_MEMBER_STATUS functions 
- Backport function QUEUE_EXISTS from 1.8
  http://svnview.digium.com/svn/asterisk?view=revision&revision=268575

* Wed Apr 18 2012 Daniel Ferrer <daniel@teledata.com.uy> 1.4.44-2.0
- Add %patch209 to pick a B channel of same group of original chan.
  Fixes problems with PRI lines when NET side uses B-channel negotiation = "Preferred", 
  before this patch asterisk picks the highest free channel in span, in descending order.

* Wed Apr 11 2012 Daniel Ferrer <daniel@teledata.com.uy> 1.4.44-1.0
- Update to 1.4.44

* Wed Mar 7 2012 Daniel Ferrer <daniel@teledata.com.uy> 1.4.43-2.0
- Modifed Patch204, for dispatching calls to a queue member when it's ringing and ringinuse=1

* Thu Jan 19 2012 Daniel Ferrer <daniel@teledata.com.uy> 1.4.43-1.0
- Update to 1.4.43
- Disable mISDN module because never was used, needed to fix compilation in CentOS 6.
- Disable conditionally patch126 in for CentOS 6, it causes a deadlock on x86_64 when loading
  chan_h323 on CentOS 6.2. Already needed for CentOS 5.

* Fri Aug 05 2011 Daniel Ferrer <daniel@teledata.com.uy> 1.4.42-2.0
- Regression: chan_h323 now depends again on OpenH323 and PWLib. Asterisk changed
  chan_h323 dependency to OpenH323 <= 1.19.0. There is a patch to build against 
  h323plus but is difficult to apply to 1.4 branch.
  (See https://reviewboard.asterisk.org/r/1117/)
- Fix module loading with global symbols bug, see ASTERISK-18227
  (https://issues.asterisk.org/jira/browse/ASTERISK-18227), reported by me
- Fix expat-devel dependency when building asterisk-chan_h323 subpackage

* Mon Aug 01 2011 Daniel Ferrer <daniel@teledata.com.uy> 1.4.42-1.0
- Update to 1.4.42
- Delete att_trans_ami patch
- Remove restriction to build against h323plus >= 1.19
- Enable plugins-tds package
- Fix ILBC, asterisk package doesn't depend on libilbc package

* Mon Apr 11 2011 Daniel Ferrer <daniel@teledata.com.uy> 1.4.29.1-4.3
- Add ILBC codec

* Tue Nov 16 2010 Daniel Ferrer <daniel@teledata.com.uy> 1.4.29.1-4.2
- Fix asterisk init script, must start on runlevel 2345 priority S90

* Fri Aug 13 2010 Daniel Ferrer <daniel@ipcontact.com.uy> 1.4.29.1-4.1
- Patch for Xorcom callerid, eliminate DC signal when detecting it

* Thu Jun 17 2010 Daniel Ferrer <daniel@ipcontact.com.uy> 1.4.29.1-4.0
- Patch9 enabled again
- Added automonitor event patch, it generates an event when automon feature is activated

* Thu Jun 03 2010 Daniel Ferrer <daniel@ipcontact.com.uy> 1.4.29.1-2.5
- Update to openr2-asterisk-1.4.28-p1.patch
- Aux version with patch9 disabled for R2 testing

* Tue Apr 06 2010 Daniel Ferrer <daniel@ipcontact.com.uy> 1.4.29.1-3.0
- Backported 1.6.2 patch from issue #9096 9096-1.6.2-branch.diff
  Add options: cidstart=dtmf and dtmfcidlevel to chan_dahdi.conf. 
  This patch works for detecting Antel callerid

* Wed Mar 24 2010 Daniel Ferrer <daniel@ipcontact.com.uy> 1.4.29.1-2.0
- Added option 'R' in app_queue, backported from asterisk trunk r236304, issue #16384.
- Added IPContact patches (improvements)
  . Parking return patch (distinctive ring for returned parked calls)
  . app_queue patch, if ringinuse=yes, ring members that are marked
    as "OnHold" or "Ring+Inuse". This delivers > 2 calls to SIP phones with
    multiple lines
  - app_voicemail preprocess patch. Adds 2 options 'preprocesscmd' and 'preprocessfmt'
    to preprocess audio voicemails to any format before attaching them
- Update Asterisk 1.4 g722 patch
- Fix safe_asterisk patch, redirect killall to /dev/null
- Delete mail option in asterisk logrotate script

* Fri Feb 19 2010 Daniel Ferrer <daniel@ipcontact.com.uy> 1.4.29.1-1.0
- Update to 1.4.29.1
- Fixed broken atxfer, backported patches:
  . patch130 (r244151), issue #16513.
  . patch131 (r244070), issues #16525, #16581, #16681

* Thu Jan 28 2010 Daniel Ferrer <daniel@ipcontact.com.uy> 1.4.29-1.0
- Update to 1.4.29
- First build with h323plus/ptlib library
- Compiled with dahdi-linux 2.2.1, dahdi-tools 2.2.1

* Mon Dec 21 2009 Daniel Ferrer <daniel@ipcontact.com.uy> 1.4.28-1.0
- Update to 1.4.28

* Thu Dec 17 2009 Daniel Ferrer <daniel@ipcontact.com.uy> 1.4.27.1-1.0
- Update to 1.4.27.1
- Patch to kill safe_asterisk on service stop (inspired on Elastix)
- Fix safe_asterisk script

* Wed Dec 16 2009 Daniel Ferrer <daniel@ipcontact.com.uy> 1.4.27-2.0
- Fix asterisk-1.4.27-qaddons.patch, ported incorrectly to 1.4.27 by me,
  function QUEUE_MEMBER_COUNT broken

* Wed Nov 25 2009 Daniel Ferrer <daniel@ipcontact.com.uy> 1.4.27-1.0
- Update to 1.4.27
- First build with OpenR2 support
- Separate MOH asterisk-moh-opsound package, asterisk-moh-freeplay packages.
  Both packages provides "asterisk-moh" needed by asterisk
- ast_do_masquerade patch

* Tue Sep 29 2009 Daniel Ferrer <daniel@ipcontact.com.uy> 1.4.26.2-2.0.debug
- Deleted "by ipcontact@ipcontact.com.uy" from version, it causes buffer overflow for
  long hostnames (80 chars max).
- Use DONT_OPTIMIZE by default, disabled rpmbuild-optimize patch
- Optional compilation with DEBUG_THREADS and other DEBUG* flags, enable with
  --with debug_threads, --with debug_channel_locks
- Changed build options. Now is not mandatory to define _GNU_SOURCE explicitly,
  it is now defined in include/asterisk/autoconfig.h (this was caused
  because AC_USE_SYSTEM_EXTENSIONS was commented out in configure.ac)
- Generate a BUILD_REPORT with compiler flags

* Fri Sep 11 2009 Daniel Ferrer <daniel@ipcontact.com.uy> 1.4.26.2-1.0
- Update to 1.4.26.2
- Add patch to app_voicemail.c. When you have only 1 message
  say '1' instead of '1M' (language 'es')
- Add patch to app_read.c to set READSTATUS variable, useful to detect
  a timeout situation

* Tue Jul 14 2009 Daniel Ferrer <daniel@ipcontact.com.uy> 1.4.26-0.rc6.1
- Update to 1.4.26-rc6, compiled against dahdi 2.2.0-2.0
- Added "Queue Member Count" patch for CLI and Manager

* Wed Jul 1 2009 Daniel Ferrer <daniel@ipcontact.com.uy> 1.4.26-0.rc4.1
- Compiled against dahdi 2.2.0-rc1
- Fix version in spec file
- Exclude /var/log/asterisk/h323.log

* Wed Jun 25 2009 Daniel Ferrer <daniel@ipcontact.com.uy> 1.4.26_rc4-1.0
- Update to 1.4.26-rc4

* Wed Jun 17 2009 Daniel Ferrer <daniel@ipcontact.com.uy> 1.4.26_rc2-1.0
- Update to 1.4.26-rc2, fix spec to support SOURCE tarball with '-'
- Fix compiler flags, pthread issue (see 1.6.1.1 rpm)
- Removed g722 moh files from package. Update to last asterisk-moh-freeplay*
- Compiled against DAHDI (default), can be compiled against Zaptel (--with zaptel)
  Compilation tested in Centos 5, Mandriva 2008.1

* Mon Jun 01 2009 Luis Vazquez <luis@ipcontact.com.uy> 1.4.24.1-4.0
- Backport snmp module from asterisk 1.6.1

* Wed May 27 2009 Daniel Ferrer <daniel@ipcontact.com.uy> 1.4.24.1-3.1
- Add patch to correct ast_do_masquerade function, to match channel cdr uniqueid 
  with channel's uniqueid 
- Add patch to CLI cmd 'sip/iax show channels' to count active real channels 
 active sip/iax dialogs

* Thu May 14 2009 Daniel Ferrer <daniel@ipcontact.com.uy> 1.4.24.1-3.0
- Generate asterisk-h323 package with chan_h323 deps (openh323, pwlib, etc)
- Fix main/asterisk link dependencies for h323, added Debian patches:
  . h323-no-deps-on-asterisk (http://patch-tracking.debian.net/patch/series/view/asterisk/1:1.4.21.2~dfsg-3/h323-no-deps-on-asterisk)
  . h323-workaround-openh323-segfault (http://patch-tracking.debian.net/patch/series/view/asterisk/1:1.4.21.2~dfsg-3/h323-workaround-openh323-segfault)
- Generate subpackage asterisn-snmp-mibs as noarch, requires rpmbuild from custom
  package rpm-build-4.4.2.3-9.1.centos5 (fixes Centos rpm noarch subpackage bug)

* Mon Apr 27 2009 Luis Vazquez <luis@ipcontact.com.uy> 1.4.24.1-2.0
- fix astNumChannel definition in asterisk MIB file
- make MIBs package independent fron asterisk main package

* Fri Apr 24 2009 Daniel Ferrer <daniel@ipcontact.com.uy> 1.4.24.1-1.1
- create data package with Asterisk SNMP MIBs

* Fri Apr 24 2009 Daniel Ferrer <daniel@ipcontact.com.uy> 1.4.24.1-1.0
- Update to 1.4.24.1
- Fix page announce patch (patch124)

* Wed Mar 04 2009 Daniel Ferrer <daniel@ipcontact.com.uy> 1.4.23.1-1.1
- fix build_h323 conditional for patch1
- disable sip tcp patch for default build

* Wed Feb 04 2009 Daniel Ferrer <daniel@ipcontact.com.uy> 1.4.23.1-1.0
- Add patch to play an intro msg in app_meetme.c, required for another
 patch in app_page.c
- Add main/channel.c patches until r170648. Issues #14206 (broken pickup), #14249
- Add res/res_features.c patch, r169868 (broken park announce where blind transfer to 700)
- less debug in fd patch
- Add applist file (old maybe)
- Requires autoconf >= 2.60

* Fri Jan 16 2009 Daniel Ferrer <daniel@ipcontact.com.uy> 1.4.22-3.1
- Centos x86_64 build, added missing %if %else deps for conditional osp, snmp, etc
- fd patch modified, less debug
- fix dependencies:
  . required mISDN-devel dependency also required for Centos
  . required openldap-devel for openh323 pwlib test (configure script)

* Mon Nov 24 2008 Daniel Ferrer <daniel@ipcontact.com.uy> 1.4.22-3.0
- Merged Centos RPM branch with Mandriva's changes since 1.4.21.2
  - Update to 1.4.22
  - Add queue_noanswer patch (cdr noapplicattion patch deleted)
  - Add iax_read patch

* Tue Oct 14 2008 Luis Vazquez <luis@ipcontact.com.uy> 1.4.21.2-5.0
- Add patches borrowed from Trixbox package:
  - add misdn jitterbuffer patch
  - add vm storage options in modules.conf
  - export Attended Transfer to Asterisk Manager Interface
  - include g722 codec support

* Mon Oct 13 2008 Luis Vazquez <luis@ipcontact.com.uy> 1.4.21.2-4.0
- fix moh install. Add gsm, g722 and g729 audio versions
- install sample configs in /etc/asterisk-{version}_samples (CentOS way)
- fix doc package building

* Wed Oct 08 2008 Luis Vazquez <luis@ipcontact.com.uy> 1.4.21.2-3.0
- port to Centos 5
 -- many fixes in spec and changes in package requirements

* Thu Sep 18 2008 Daniel Ferrer <daniel@ipcontact.com.uy> 1.4.21.2-2.0mdv2008.1
- Added spanish SayNumber patch

* Mon Aug 11 2008 Daniel Ferrer <daniel@ipcontact.com.uy> 1.4.21.2-1.0mdv2008.1
- Update to version 1.4.21.2

* Mon Jul 14 2008 Daniel Ferrer <daniel@ipcontact.com.uy> 1.4.21.1-2.1mdv2008.1
- No CDRfix4 patch
- cdr.conf option 'noapplication' added

* Fri Jul 11 2008 Daniel Ferrer <daniel@ipcontact.com.uy> 1.4.21.1-2.0mdv2008.1
- Added CDRfix4 patch from murf, http://bugs.digium.com/view.php?id=10927
- fix spec file for x86_64 compilation

* Thu Jul 03 2008 Daniel Ferrer <daniel@ipcontact.com.uy> 1.4.21.1-1.0mdv2008.1
- Update to version 1.4.21.1

* Thu Jun 19 2008 Daniel Ferrer <daniel@ipcontact.com.uy> 1.4.19-4.1mdv2007.1
- Fix for skipping h323 build (--withouth h323 option)
- BUSYDETECT* option added to Makefile

* Mon Apr 27 2008 Luis Vazquez <luis@teledata.com.uy> 1.4.19-4.0mdv2007.1
- add AGX patches for chan_sip an chan_misdn submitted to Digium
 but not included in main distribution

* Mon Apr 27 2008 Luis Vazquez <luis@teledata.com.uy> 1.4.19-3.0mdv2007.1
- add Huawei SIP DTMF patch
- fix h323 build in Mandriva 2008.1 (needs fix in Mandriva openh323u.mak)

* Fri Apr 25 2008 Luis Vazquez <luis@teledata.com.uy> 1.4.19-2.0mdv2007.1
- fix segfault bug in monitor show connected
- fix using safe_asterisk in asterisk init script

* Mon Jan 21 2008 Luis Vazquez <luis@teledata.com.uy> 1.4.19-1.1mdv2007.1
- made spec to enable highpriority and languagerprefix options in asterisk.conf

* Mon Jan 21 2008 Luis Vazquez <luis@teledata.com.uy> 1.4.19-1.0mdv2007.1
- version 1.4.19

* Mon Jan 21 2008 Luis Vazquez <luis@teledata.com.uy> 1.4.13-1.3mdv2007.1
- Build with h323 enabled

* Mon Jan 21 2008 Luis Vazquez <luis@teledata.com.uy> 1.4.13-1.1mdv2007.1
- Remove app_fax from main build
- add sysinfo patch

* Mon Jan 21 2008 Luis Vazquez <luis@teledata.com.uy> 1.4.13-1mdv2007.1
- 1.4.13

* Fri Oct 09 2007 Luis Vazquez <luis@teledata.com.uy> 1.4.12-1.1mdv2007.1
- Fix on safe_asterisk, sysconfig and init scripts 

* Fri Oct 09 2007 Luis Vazquez <luis@teledata.com.uy> 1.4.12-1mdv2007.1
- First IPContact asterisk 1.4 build

* Sun Sep 09 2007 Stefan van der Eijk <stefan@mandriva.org> 1.4.11-2mdv2008.0
+ Revision: 83544
- fix chan_sip INFO content length = 0
- new SIP over tcp patch
- enable SIP over tcp for now

* Sat Aug 25 2007 Stefan van der Eijk <stefan@mandriva.org> 1.4.11-1mdv2008.0
+ Revision: 71358
- add BuildRequires: perl-devel
- 1.4.11

  + Oden Eriksson <oeriksson@mandriva.com>
    - rebuilt against latest net-snmp-devel

* Wed Aug 08 2007 Stefan van der Eijk <stefan@mandriva.org> 1.4.10-1mdv2008.0
+ Revision: 60039
- 1.4.10

* Wed Jul 25 2007 Stefan van der Eijk <stefan@mandriva.org> 1.4.9-1mdv2008.0
+ Revision: 55187
- 1.4.9

* Tue Jul 24 2007 Oden Eriksson <oeriksson@mandriva.com> 1.4.8-2mdv2008.0
+ Revision: 54917
- fix build
- fix #29812
- use the new %%serverbuild macro
- spec file cleansing

  + Stefan van der Eijk <stefan@mandriva.org>
    - adjust BuildRequires to new dev package standard (cough)
    - 1.4.8

* Tue Jul 10 2007 Stefan van der Eijk <stefan@mandriva.org> 1.4.7.1-1mdv2008.0
+ Revision: 51072
- 1.4.7.1

* Tue Jul 10 2007 Stefan van der Eijk <stefan@mandriva.org> 1.4.7-1mdv2008.0
+ Revision: 50816
- 1.4.7

* Fri Jun 29 2007 Stefan van der Eijk <stefan@mandriva.org> 1.4.6-1mdv2008.0
+ Revision: 45922
- 1.4.6

* Sat Jun 16 2007 Stefan van der Eijk <stefan@mandriva.org> 1.4.5-1mdv2008.0
+ Revision: 40346
- 1.4.5

* Thu May 31 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 1.4.4-2mdv2008.0
+ Revision: 33294
- Rebuild with libnewt0.52.

* Wed May 02 2007 Stefan van der Eijk <stefan@mandriva.org> 1.4.4-1mdv2008.0
+ Revision: 20522
- 1.4.4

* Wed Apr 25 2007 Stefan van der Eijk <stefan@mandriva.org> 1.4.3-1mdv2008.0
+ Revision: 18328
- 1.4.3


* Fri Mar 30 2007 Stefan van der Eijk <stefan@mandriva.org> 1.4.2-1mdv2007.1
+ Revision: 149806
- 1.4.2

* Sun Mar 04 2007 Stefan van der Eijk <stefan@mandriva.org> 1.4.1-1mdv2007.1
+ Revision: 132083
- rm -rf instead of rm -f
- sort out more of the sounds stuff
- 1.4.1
- remove gtalk patches (merged upstream)
- disable build_tds for now (patch broke)

* Thu Feb 15 2007 Oden Eriksson <oeriksson@mandriva.com> 1.4.0-4mdv2007.1
+ Revision: 121453
- use the stand alone asterisk-core-sounds package instead

* Mon Feb 12 2007 Stefan van der Eijk <stefan@mandriva.org> 1.4.0-3mdv2007.1
+ Revision: 118837
- add gtalk / jabber patches from http://bugs.digium.com/view.php?id=7764
- change permisions on configuration files
- comment out unused patches
- bump release

* Fri Dec 29 2006 Stefan van der Eijk <stefan@mandriva.org> 1.4.0-2mdv2007.1
+ Revision: 102675
- disable SIP over TCP / TLS for now
- add some missing dirs
- updated SIP over TCP / TLS patch to 20061212, but it doesn't apply 100%%

* Sun Dec 24 2006 Stefan van der Eijk <stefan@mandriva.org> 1.4.0-1mdv2007.1
+ Revision: 101978
- 1.4.0
